import numpy
import matplotlib.pylab as p
from mpl_toolkits.mplot3d import Axes3D
import os
import sys

# Global variables
NMAX = int(sys.argv[1])
NITER = int(sys.argv[2])
V = os.environ.get("V", numpy.zeros((NMAX, NMAX), float))


def computing():
    print("Initializing...")

    for k in range(0, NMAX - 1): V[k, 0] = 100

    for iter in range(NITER):
        if iter % 10 == 0:
            print(iter)
        for i in range(1, NMAX - 2):
            for j in range(1, NMAX - 2): V[i, j] = 0.25 * (V[i + 1, j] + V[i - 1, j] + V[i, j + 1] + V[i, j - 1])
    x = range(0, NMAX - 1, 2)
    y = range(0, 50, 2)
    X, Y = p.meshgrid(x, y)
    return X, Y


def functz(X, Y):
    z = V[X, Y]
    return z


def main():
    X, Y = computing()
    Z = functz(X, Y)
    fig = p.figure()
    ax = Axes3D(fig)
    ax.plot_wireframe(X, Y, Z, color='r')
    ax.set_xlabel('X')
    ax.set_xlabel('Y')
    ax.set_xlabel('Potential')
    p.show()


if __name__ == "__main__":
    main()
