import argparse
import numpy
import matplotlib.pylab as plt
from mpl_toolkits.mplot3d import Axes3D
import os


def func_z(X, Y):
    return V[X, Y]


def compute():
    print("Initializing...")

    for k in range(0, N_MAX - 1):
        V[k, 0] = 100

    for i in range(N_I):
        if i % 10 == 0:
            print(i)
        for y in range(1, N_MAX - 2):
            for x in range(1, N_MAX - 2):
                V[y, x] = 0.25 * (V[y + 1, x] + V[y - 1, x] + V[y, x + 1] + V[y, x - 1])
    x = range(0, N_MAX - 1, 2)
    y = range(0, 50, 2)
    X, Y = plt.meshgrid(x, y)
    return X, Y


def main():
    X, Y = compute()
    Z = func_z(X, Y)

    fig = plt.figure()
    ax = Axes3D(fig)
    ax.plot_wireframe(X, Y, Z, color='r')
    ax.set_xlabel('X')
    ax.set_ylabel('Y')
    ax.set_zlabel('Potential')
    plt.show()


if __name__ == "__main__":
    parser = argparse.ArgumentParser()
    parser.add_argument('--n_max', type=int, required=False, default=100)
    parser.add_argument('--n_i', type=int, required=False, default=70)
    args = parser.parse_args()

    N_MAX, N_I = args.n_max, args.n_i
    V = os.environ.get("V", numpy.zeros((N_MAX, N_MAX), float))

    main()
